#import <Cocoa/Cocoa.h>

#import "PPImageView.h"

@class SyncHelper;

@interface AppDelegate : NSObject 
{
	IBOutlet NSWindow *window;
	IBOutlet PPImageView *imageView;
  IBOutlet NSTableView *recipeIngredientTableView;
	IBOutlet NSArrayController *recipeArrayController;
	IBOutlet NSArrayController *recipeIngredientArrayController;
	IBOutlet NSArrayController *exportArrayController;
	IBOutlet NSPanel *exportSheet;
  IBOutlet NSPanel *ingredientEditSheet;
	
	NSPersistentStoreCoordinator *persistentStoreCoordinator;
	NSManagedObjectModel *managedObjectModel;
	NSManagedObjectContext *managedObjectContext;
	
	SyncHelper *syncHelper;
	
	NSOperationQueue *genericOperationQueue;
}

- (NSPersistentStoreCoordinator *)persistentStoreCoordinator;
- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;
- (NSString*)applicationSupportFolder;

- (IBAction)saveAction:sender;
- (IBAction)addImage:(id)sender;
- (IBAction)addIngredient:(id)sender;
- (IBAction)editIngredient:(id)sender;
- (IBAction)ingredientSheetSave:(id)sender;
- (IBAction)ingredientSheetCancel:(id)sender;

- (BOOL)save:(NSError**)error;

- (NSString*)metadataFolder:(NSError**)error;

//START:ExportRecipes
- (IBAction)exportRecipes:(id)sender;
- (IBAction)exportApproved:(id)sender;
- (IBAction)exportCancelled:(id)sender;
//END:ExportRecipes

- (IBAction)importRecipes:(id)sender;

- (void)refreshRecipeList:(NSArray*)objectIDArray;

@end
